/* without .syntax unified, it doesn't seem to honor whether the suffix
 * 's'etflags is present?? */
.syntax unified

.equ OFS_XOR,0x1000		/* offsets to add to 4kB I/O regions for */
.equ OFS_OR,0x2000		/* atomic bitwise manipulation */
.equ OFS_ANDNOT,0x3000

.equ SYSINFO_BASE,0x40000000
.equ SYSCFG_BASE,0x40004000
.equ CLOCKS_BASE,0x40008000
.equ RESETS_BASE,0x4000c000

.equ IO_BANK0_BASE,0x40014000
.equ GPIO25_STATUS,IO_BANK0_BASE+25*8+0
.equ GPIO25_CTRL,IO_BANK0_BASE+25*8+4

.equ SIO_BASE,0xd0000000

.equ PSM_BASE,0x40010000
.equ PSM_WDSEL,PSM_BASE+0x08

.equ RESETS_BASE,0x4000c000
.equ RESETS_RESET,RESETS_BASE+0x00

.equ WDT_BASE,0x40058000
.equ WDT_CTRL,WDT_BASE+0x00
.equ WDT_LOAD,WDT_BASE+0x04
.equ WDT_REASON,WDT_BASE+0x08
.equ WDT_SCRATCH,WDT_BASE+0x0c	/* 32 bytes */
.equ WDT_TICK,WDT_BASE+0x2c



.section .start
.global start
.type start,function
start:
	ldr r0,=.stack+4096		/* stack grows towards smaller addrs */
	mov sp,r0

	ldr r0,=0xffffff
	ldr r1,=WDT_LOAD
	str r0,[r1]

	ldr r0,=0x206		/* enable, cycles=6, for 1us off 6MHz ROSC?? */
	ldr r1,=WDT_TICK
	str r0,[r1]

	ldr r0,=0x0001fffc	/* WDT resets everything but ROSC,XOSC */
	ldr r1,=PSM_WDSEL
	str r0,[r1]

	ldr r0,=0x40000000		/* enable */
	ldr r1,=WDT_CTRL+OFS_OR
	str r0,[r1]

	ldr r0,=(1<<5)			/* enable IO_BANK0 */
	ldr r1,=RESETS_RESET+OFS_ANDNOT
	str r0,[r1]


	ldr r0,=0x0000331f		/* OEOVER=3 enable output,
					 * OUTOVER=3 output high
					 * FUNCSEL=31 NULL */
	ldr r3,=0x00000100		/* XOR value (OUTOVER=2 output low) */
	ldr r1,=GPIO25_CTRL
outer_loop:
	str r0,[r1]

	ldr r2,=(6500000/3)		/* 6.5MHz / 3 cycles for the loop */
delay:	subs r2,r2,#1			/* 1 cycle */
	bne delay			/* 2 cycle (if taken) */

	eors r0,r3
	b outer_loop

infloop:	b infloop
	
/*
XXX - what is SYSINFO and SYSCFG that could be in RESETS?
*/

.section .stack
